/*****************************************************************************/
/* Software Testing Automation Framework (STAF)                              */
/* (C) Copyright IBM Corp. 2009                                              */
/*                                                                           */
/* This software is licensed under the Eclipse Public License (EPL) V1.0.    */
/*****************************************************************************/

import com.zerog.ia.api.pub.*;
import java.io.*;
public class STAFCheckPerlVersion extends CustomCodeAction
{
    public void install(InstallerProxy ip)
    {
        String usePerlSystemPath = ip.substitute("$USE_PERL_SYSTEM_PATH$");

        if (usePerlSystemPath.equals("1"))
        {
            Process p = null;
            java.util.Properties envVars = new java.util.Properties();
            Runtime r = Runtime.getRuntime();
            String line = "";
            String perlVersion = "";

            try
            {
                String command = "perl -v";

                p = r.exec(command);

                BufferedReader br = new
                    BufferedReader(new InputStreamReader(p.getInputStream()));

                while ((line = br.readLine()) != null)
                {
                    if (line.startsWith("This is perl, v"))
                    {
                        String version = line.substring(15, line.indexOf(" ", 15));
                        int lastPeriod = version.lastIndexOf('.');
                        perlVersion = version.substring(0, lastPeriod);
                    }
                }

                if (perlVersion.equals("5.8"))
                {
                    ip.setVariable("$USE_PERL_VERSION$", "5.8");
                }
                else if (perlVersion.equals("5.10"))
                {
                    ip.setVariable("$USE_PERL_VERSION$", "5.10");
                }
                else if (perlVersion.equals("5.6"))
                {
                    ip.setVariable("$USE_PERL_VERSION$", "5.6");
                }
            }
            catch (IOException e) { }
        }
    }

    public void uninstall(UninstallerProxy up)
    {
    }

    public String getInstallStatusMessage()
    {
        return "";
    }

    public String getUninstallStatusMessage()
    {
        return "";
    }
}