<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>

<head>
  <title>Software Testing Automation Framework (STAF)</title>
</head>

<body>

<?php
require "top.php";
require "navigate.php";
?>

<!-- Insert text for page here -->

<tr>
<td>

<center><a name=top><h1>Download STAX Service for STAF V3</h1></center>
<p>
The latest release of the STAX service for STAF V3 can be downloaded from
this page.  If you want to download STAX for STAF V2, go to the
<a href="getstax2x.php">Download STAX V2"</a> page instead.
<p>
STAX is an execution engine which can help you thoroughly automate the
distribution, execution, and results analysis of your testcases. STAX builds on top of
three existing technologies, STAF, XML, and Python, to place great automation power in
the hands of testers. STAX also provides a powerful GUI monitoring application which
allows you to interact with and monitor the progress of your jobs.
<br>
See the <a href="latest.php">Programmatically retrieving the latest STAF
releases</a> page for more information about how to programmatically retrieve the
latest STAF releases.
<p>
The latest releases of the STAX service are:
<ul>
<li><a href="#V3.4.5">STAX Version 3.4.5</a>:
    Latest official release.  Uses Jython 2.1.
<p>
<li><a href="#V3.5.0">STAX Version 3.5.0 Beta 1</a>:
    Beta release.
    The purpose of this Beta is to provide support for Jython 2.5.2 (instead
    of Jython 2.1 which is what is supported by previous STAX versions).
    However, because the final Jython 2.5.2 version has not yet been released
    and because we don't have approval to distribute the final Jython 2.5.2
    version yet, the STAX service jar file provided by it does not contain
    Jython 2.5.2.  You need to download the latest version of Jython 2.5.2
    available via the Jython website and install it and then run the provided
    STAXJarUpdateForJython252 Java application to create a STAX.jar file
    to use for registering the STAX V3.5.0 Beta 1 service.
    Follow the instructions for how to do this in the
    <a href="STAXBeta/staxug.html#Header_StaxServiceMach">Installation and
    Configuration</a> section for the STAX Service Machine in the
    STAX V3.5.0 Beta 1 User's Guide.
</ul>
<p>
<a name="V3.4.5"><font face="arial, helvetica" color="#1e029a" size="4"><b>STAX Version 3.4.5</b></font></a>
<p>
<b>Note:</b>  The STAX V3.4.5 Service requires STAF V3.3.4 or later and the
   STAX V3.4.5 Monitor requires STAF V3.3.3 or later and STAX V3.4.5 Service.
<p>
Reference the <a href="staxhistory.php">STAX History</a> page for STAX version and history
information.
<p>
<table border="1">
<tr>
  <td><b>Platform</td>
  <td><b>File</b></td>
  <td><b>File format</b></td>
  <td><b>File size</b></td>
</tr>
<tr>
  <td>Windows</td>
  <td><a href="http://prdownloads.sourceforge.net/staf/STAXV345.zip">STAXV345.zip</a></td>
  <td>zip file</td>
  <td>7.9M</td>
</tr>
<tr>
  <td>Unix</td>
  <td><a href="http://prdownloads.sourceforge.net/staf/STAXV345.tar">STAXV345.tar</a></td>
  <td>tar file</td>
  <td>9.0M</td>
</tr>
</table>

<p>
<h3>Documentation</h3>

<table border="1">
<tr><td><b>Document</b></td><td><b>File</b></td></tr>
<tr>
  <td><a href="current/staxgs.pdf">Getting Started with STAX V3 (PDF)</a></td>
  <td>staxgs.pdf</td>
</tr>
<tr>
  <td><a href="current/STAX/staxug.html">STAX V3.4.5 User's Guide (HTML)</a> - View</td>
  <td>staxug.html</td>
</tr>
<tr>
  <td><a href="current/staxug.pdf">STAX V3.4.5 User's Guide (PDF)</a> - Download/View</td>
  <td>staxug.pdf</td>
</tr>
<tr>
  <td><a href="current/STAXDoc.pdf">STAXDoc User's Guide (PDF)</a></td>
  <td>STAXDoc.pdf</td>
</tr>
<tr>
  <td><a href="current/staxdg.html">STAX V3 Extensions Developer's Guide (HTML)</a></td>
  <td>staxdg.html</td>
</tr>
<tr>
  <td><a href="current/STAXLibraries/index.html">STAX V3 Library Function Definitions for STAFUpgradeUtil and STAXUtil</a></td>
  <td></td>
</tr>
</table>

<p>
<a name="V3.5.0"><font face="arial, helvetica" color="#1e029a" size="4"><b>STAX Version 3.5.0 Beta 1</b></font></a>
<p>
<b>Note:</b>  The STAX V3.5.0 Beta 1 Service requires STAF V3.3.4 or later and the
   STAX V3.5.0 Beta 1 Monitor requires STAF V3.3.3 or later and STAX V3.5.0 Beta 1 Service or later.
<p>
Reference the <a href="staxbetahistory.php">STAX History</a> page for STAX version and history
information.
<p>
<table border="1">
<tr>
  <td><b>Platform</td>
  <td><b>File</b></td>
  <td><b>File format</b></td>
  <td><b>File size</b></td>
</tr>
<tr>
  <td>Windows</td>
  <td><a href="http://prdownloads.sourceforge.net/staf/STAXV350Beta1.zip">STAXV350Beta1.zip</a></td>
  <td>zip file</td>
  <td>6.7M</td>
</tr>
<tr>
  <td>Unix</td>
  <td><a href="http://prdownloads.sourceforge.net/staf/STAXV350Beta1.tar">STAXV350Beta1.tar</a></td>
  <td>tar file</td>
  <td>7.8M</td>
</tr>
</table>

<p>
<h3>Documentation</h3>

<table border="1">
<tr><td><b>Document</b></td><td><b>File</b></td></tr>
<tr>
  <td><a href="current/staxgs.pdf">Getting Started with STAX V3 (PDF)</a></td>
  <td>staxgs.pdf</td>
</tr>
<tr>
  <td><a href="STAXBeta/staxug.html">STAX V3.5.0 Beta 1 User's Guide (HTML)</a> - View</td>
  <td>staxug.html</td>
</tr>
<tr>
  <td><a href="STAXBeta/staxug.pdf">STAX V3.5.0 Beta 1 User's Guide (PDF)</a> - Download/View</td>
  <td>staxug.pdf</td>
</tr>
<tr>
  <td><a href="current/STAXDoc.pdf">STAXDoc User's Guide (PDF)</a></td>
  <td>STAXDoc.pdf</td>
</tr>
<tr>
  <td><a href="current/staxdg.html">STAX V3 Extensions Developer's Guide (HTML)</a></td>
  <td>staxdg.html</td>
</tr>
<tr>
  <td><a href="current/STAXLibraries/index.html">STAX V3 Library Function Definitions for STAFUpgradeUtil and STAXUtil</a></td>
  <td></td>
</tr>
</table>
<p>
<p>

<!-- end of text for page -->

<?php
require "bottom.php";
?>

</body>
</html>





